'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Class AnemicModel have the responsibility of implement the common constructor and toJSON
 * code routines and make it transparent to our consumer.
 */
var AnemicModel = function () {
  function AnemicModel() {
    var _this = this;

    var properties = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck3.default)(this, AnemicModel);

    (0, _keys2.default)(properties).forEach(function (key) {
      return _this['_' + key] = properties[key];
    });
    Object.defineProperty(this, '_properties', {
      value: properties,
      writable: false,
      enumerable: false,
      configurable: false
    });
  }

  /**
   * Method toJSON will get our object keys and transform it to the same structure as our input object.
   * The method will:
   * 1 - replace key _myPropertyKey by myPropertyKey
   * 2 - Check if the property was existing on the base properties constructor object or was added later. If second it will not included on te toJSON
   * 3 - Check if the property is AnemicObject and call its toJSON method too to get their JSON aspect.
   * 4 - Check if is an array, if it is will check if is an AnemicObject and do the same as step 3
   * 5 - If any of the latest steps were successful it will return the property without the dash.
   *
   * @returns {*}
   */


  (0, _createClass3.default)(AnemicModel, [{
    key: 'toJSON',
    value: function toJSON() {
      var _this2 = this;

      return (0, _keys2.default)(this).reduce(function (resultObject, key) {
        var replacedKey = key.replace('_', '');

        if (!_this2._properties.hasOwnProperty(replacedKey)) {
          return resultObject;
        }

        if (_this2._properties[replacedKey] instanceof AnemicModel) {
          return (0, _extends4.default)({}, resultObject, (0, _defineProperty3.default)({}, replacedKey, _this2._properties[replacedKey].toJSON()));
        }

        if (Array.isArray(_this2._properties[replacedKey])) {
          resultObject[replacedKey] = _this2._properties[replacedKey].map(function (obj) {
            if (obj instanceof AnemicModel) {
              return obj.toJSON();
            }

            return obj;
          });

          return resultObject;
        }

        resultObject[replacedKey] = _this2._properties[replacedKey];
        return resultObject;
      }, {});
    }
  }]);
  return AnemicModel;
}();

exports.default = AnemicModel;